Package org.apache.groovy.contracts.ast.visitor

# Class AnnotationClosureVisitor

java.lang.Object
org.codehaus.groovy.ast.CodeVisitorSupport
org.codehaus.groovy.ast.ClassCodeVisitorSupport
org.apache.groovy.contracts.ast.visitor.BaseVisitor
org.apache.groovy.contracts.ast.visitor.AnnotationClosureVisitor

All Implemented Interfaces:
  `ASTNodeMetaData`, `GroovyClassVisitor`, `GroovyCodeVisitor`, `ErrorCollecting`

public class AnnotationClosureVisitor extends BaseVisitor implements ASTNodeMetaData
Visits interfaces & classes and looks for `@Requires` or `@Ensures` and creates `Closure` classes for the annotation closures.

The annotation closure classes are used later on to check interface contract pre- and post-conditions in implementation classes.

See Also:
  - `Requires`
  - `Ensures`
  - `BaseVisitor`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `META_DATA_ORIGINAL_TRY_CATCH_BLOCK`
  Metadata key used to stash the original try/catch wrapped assertion block for later phases.
  `static final String`
  `META_DATA_USE_EXECUTION_TRACKER`
  Metadata flag indicating that the rewritten closure performs method calls and therefore needs execution tracking instead of inline expansion.
  `static final String`
  `OLD_REFERENCES_KEY`
  Node metadata key for the set of field names referenced via `old.xxx` in postconditions.

  ### Fields inherited from class org.apache.groovy.contracts.ast.visitor.BaseVisitor

  `GCONTRACTS_ENABLED_VAR, sourceUnit`

  ### Fields inherited from interface org.apache.groovy.contracts.ast.visitor.ASTNodeMetaData

  `CLOSURE_REPLACED, PROCESSED`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AnnotationClosureVisitor(SourceUnit sourceUnit, ReaderSource source)`
  Creates a visitor that rewrites contract annotation closures into generated closure classes.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `visitClass(ClassNode classNode)`
  Rewrites class-level contract closures and then recurses into inherited types that may also contribute contract annotations.
  `void`
  `visitConstructorOrMethod(MethodNode methodNode, boolean isConstructor)`
  Rewrites method- and constructor-level contract closures into generated closure classes and records auxiliary metadata needed by later transformation phases.

  ### Methods inherited from class org.apache.groovy.contracts.ast.visitor.BaseVisitor

  `asConditionExecution, getOriginalCondition, getReplacedCondition, getSourceUnit, replaceCondition`

  ### Methods inherited from class org.codehaus.groovy.ast.ClassCodeVisitorSupport

  `addError, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop, visitYieldStatement`

  ### Methods inherited from class org.codehaus.groovy.ast.CodeVisitorSupport

  `afterSwitchCaseStatementsVisited, afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBooleanExpression, visitBytecodeExpression, visitCastExpression, visitClassExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitEmptyStatement, visitFieldExpression, visitGStringExpression, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitchExpression, visitTernaryExpression, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.codehaus.groovy.ast.GroovyCodeVisitor

  `visit, visit, visitEmptyExpression, visitListOfExpressions`

- ## Field Details

  - ### META_DATA_USE_EXECUTION_TRACKER

    public static final String META_DATA_USE_EXECUTION_TRACKER
    Metadata flag indicating that the rewritten closure performs method calls and therefore needs execution tracking instead of inline expansion.
    See Also:
      - Constant Field Values

  - ### META_DATA_ORIGINAL_TRY_CATCH_BLOCK

    public static final String META_DATA_ORIGINAL_TRY_CATCH_BLOCK
    Metadata key used to stash the original try/catch wrapped assertion block for later phases.
    See Also:
      - Constant Field Values

  - ### OLD_REFERENCES_KEY

    public static final String OLD_REFERENCES_KEY
    Node metadata key for the set of field names referenced via `old.xxx` in postconditions.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### AnnotationClosureVisitor

    public AnnotationClosureVisitor(SourceUnit sourceUnit, ReaderSource source)
    Creates a visitor that rewrites contract annotation closures into generated closure classes.
    Parameters:
      `sourceUnit` - the source unit currently being transformed
      `source` - the reader source backing the source unit

- ## Method Details

  - ### visitClass

    public void visitClass(ClassNode classNode)
    Rewrites class-level contract closures and then recurses into inherited types that may also contribute contract annotations.
    Specified by:
      `visitClass` in interface `GroovyClassVisitor`
    Overrides:
      `visitClass` in class `ClassCodeVisitorSupport`
    Parameters:
      `classNode` - the class currently being visited

  - ### visitConstructorOrMethod

    public void visitConstructorOrMethod(MethodNode methodNode, boolean isConstructor)
    Rewrites method- and constructor-level contract closures into generated closure classes and records auxiliary metadata needed by later transformation phases.
    Overrides:
      `visitConstructorOrMethod` in class `ClassCodeVisitorSupport`
    Parameters:
      `methodNode` - the method or constructor being visited
      `isConstructor` - whether the visited executable is a constructor